SystemOrganization addCategory: #FRP!

Morph subclass: #Timer
	instanceVariableNames: 'state interval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!Timer methodsFor: 'nil' stamp: 'zz 5/13/2008 14:34'!
initialize

	super initialize.
	state := #stopped.
	interval := 1000! !

!Timer methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:18'!
interval: anInterval

	interval := anInterval! !

!Timer methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:18'!
isRunning

	^ state == #run! !

!Timer methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:33'!
startTimer

	state := #run! !

!Timer methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:41'!
step

	self isRunning
		ifTrue: [self triggerEvent: #tick]! !

!Timer methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:17'!
stepTime

	^ interval! !

!Timer methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:33'!
stopTimer

	state := #stopped! !

Object subclass: #FRPAbstractBehavior
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPAbstractBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 12:38'!
initialValue: aValue

value := aValue! !

!FRPAbstractBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 12:38'!
value

^value! !

!FRPAbstractBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 12:39'!
value: aValue

self subclassResponsibility! !

FRPAbstractBehavior subclass: #FRPConstantBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPConstantBehavior commentStamp: 'zz 5/9/2008 11:39' prior: 0!
A Behavior whose value never changes!

!FRPConstantBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 12:41'!
value: aValue

^ self shouldNotImplement! !

FRPAbstractBehavior subclass: #FRPDefaultBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPDefaultBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 13:49'!
recomputeValue

	self subclassResponsibility! !

!FRPDefaultBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 12:57'!
value: aValue

(aValue == value) ifFalse:
	[value := aValue.
	self triggerEvent: #changedValue]! !

FRPDefaultBehavior subclass: #FRPTime
	instanceVariableNames: 'timer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:54'!
eventOccured

! !

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:53'!
initialize

	timer := Timer new.
	timer
		when: #tick
		send: #eventOccured
		to: self! !

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 13:50'!
recomputeValue
! !

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:46'!
start


timer start! !

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 14:46'!
stop


timer stop! !

Object subclass: #FRPAbstractEventSource
	instanceVariableNames: 'scheduler occurence cacheTimeStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPAbstractEventSource classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:17'!
new

	^ super new scheduler: FRPScheduler currentScheduler! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:27'!
-=> aValue
"Bind combinator"
	^ FRPBindEventSource eventSource: self bind: aValue! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:11'!
event

	scheduler currentTimeStep ~= cacheTimeStep
		ifTrue: [occurence := nil.
			cacheTimeStep := scheduler currentTimeStep.
			self recomputeOccurence].
	^ occurence! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:11'!
event: anEvent

	occurence := anEvent.
	cacheTimeStep := scheduler currentTimeStep.
	self triggerEvent: #FRPEventOccured with: self! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:11'!
initialize

	occurence := nil.
	cacheTimeStep := -1! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:11'!
recomputeOccurence

	self subclassResponsibility! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:16'!
scheduler: aScheduler


scheduler := aScheduler! !

FRPAbstractEventSource subclass: #FRPAbstractEventSourceListener
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPAbstractEventSourceListener methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:42'!
eventOccured: anEvent

self subclassResponsibility! !

FRPAbstractEventSourceListener subclass: #FRPBindEventSource
	instanceVariableNames: 'eventSource bindValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPBindEventSource classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:25'!
eventSource: anEventSource bind:aBindValue

^(super new) eventSource: anEventSource; bindValue: aBindValue! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:58'!
bindValue: aValue

	bindValue := aValue! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:58'!
eventOccured: anEvent

	self
		event: (FRPObjectEvent withValue: bindValue)! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:58'!
eventSource: anFRPSourceEvent

	eventSource := anFRPSourceEvent! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:59'!
recomputeOccurence

	eventSource event! !

FRPAbstractEventSourceListener subclass: #FRPMergeEventSource
	instanceVariableNames: 'firstEventSource secondEventSource lastOccurenceTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPMergeEventSource classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 13:48'!
between: firstEventSource and: secondEventSource

^(super new) firstEventSource: firstEventSource; secondEventSource: secondEventSource! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:12'!
eventOccured: anEvent

	scheduler currentTimeStep = lastOccurenceTime
		ifTrue: [self error: 'EventMerge: got a simultaneous occurence in this time step (dropping occurnce)']
		ifFalse: [lastOccurenceTime := scheduler currentTimeStep.
			self event: anEvent]! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:09'!
firstEventSource: anEventSource

	firstEventSource := anEventSource.
	anEventSource
		when: #FRPEventOccured
		send: #eventOccured:
		to: self! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:09'!
initialize

	lastOccurenceTime := -1! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:09'!
recomputeOccurence

	firstEventSource event.
	secondEventSource event! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:12'!
secondEventSource: anEventSource

	secondEventSource := anEventSource.
	anEventSource
		when: #FRPEventOccured
		send: #eventOccured
		to: self! !

FRPAbstractEventSource subclass: #FRPAnyButtonPressedEventSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPAnyButtonPressedEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 13:30'!
recomputeOccurence

	Transcript show:'Recompute occurence ...'; cr.
	Sensor anyButtonPressed 
		ifTrue: [occurence := true. Transcript show:'bip']
		ifFalse: [occurence := nil]! !

FRPAbstractEventSource subclass: #FRPLeftButtonPressedEventSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPLeftButtonPressedEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:52'!
recomputeOccurence

	Sensor redButtonPressed
		ifTrue: [occurence := true]
		ifFalse: [occurence := nil]! !

Object subclass: #FRPEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

FRPEvent subclass: #FRPObjectEvent
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPObjectEvent methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:55'!
value

	^ value! !

Object subclass: #FRPScheduler
	instanceVariableNames: 'currentTimeStep numberCalls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

FRPScheduler class
	instanceVariableNames: 'currentScheduler'!

FRPScheduler class
	instanceVariableNames: 'currentScheduler'!

!FRPScheduler classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:13'!
currentScheduler
	"singleton"
	currentScheduler isNil
		ifTrue: [currentScheduler := FRPScheduler new].
	^ currentScheduler! !

!FRPScheduler classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:56'!
example
	|  e leftButtonPressed |
	leftButtonPressed := FRPLeftButtonPressedEventSource new.
	e := leftButtonPressed -=> Color red.
	FRPScheduler currentScheduler start.
	^e! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 10:58'!
beginInputStep

numberCalls = 0 ifTrue:[currentTimeStep := currentTimeStep + 1].
numberCalls := numberCalls + 1! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 13:20'!
currentTimeStep

^currentTimeStep ! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:00'!
endInputStep

numberCalls := numberCalls - 1! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 10:56'!
initialize

currentTimeStep := 0.
numberCalls := 0! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 10:56'!
start

self beginInputStep.
self endInputStep! !
